import wx
import types

scene=poser.Scene()

selectedFigure=None
slctFigName=' '
productName=' '
furProp=None

# gets the geometry belonging to hairActor and counts all polys
# and counts the polys that are in the group grpName
# returns True if all actor polys are in the group False if not
def checkHairCoverage(hairActor,grpName):
    actName=hairActor.Name()
    actGeom=hairActor.Geometry()
    polyCounts=[0,0]

    for poly in actGeom.Polygons():
        polyCounts[0]=polyCounts[0]+1
        if poly.InGroup(grpName):
            polyCounts[1]=polyCounts[1]+1

    if polyCounts[1]==polyCounts[0]:
        return True
    else:
        return False

# gets the number of hair groups in figActor and makes a list of the group names
# CALLS checkHairCoverage and makes a coresponding list of fully populated or not
# returns a two dimensional list of group names and populated bool
def getHairGroups(figActor):
    figName=figActor.Name()
    hairGrpNames=[]
    groupPop=[]
    groupCount=figActor.NumHairGroups()
    i=0

    while i<groupCount:
        hairGrp=figActor.HairGroup(i)
        hgName=hairGrp.Name()
        hairGrpNames.append(hgName)
        groupPop.append(checkHairCoverage(figActor,hgName))
        i=i+1

    actHairStats=[hairGrpNames,groupPop]
    return actHairStats


# makes a list of the polygon indices for hair growth groups that do not
# completely cover the hair actor (body part)
# returns the list
def getHairGroupIndices(hairAct,hgName):
    indices=[]
    i=0
    actGeom=hairAct.Geometry()

    for poly in actGeom.Polygons():
        if poly.InGroup(hgName):
            indices.append(i)

        i=i+1

    return indices


# CALLS getHairGroups on figActor to get the hair stats 2D list
# CALLS getHairGroupIndicies to get the polygon indices list for any
# hair growth group that is not fully populating figActor (body part)
# ... builds a growth group polygon set dictionary with key == the hairProp's internal name
def buildPolyGroupData(figActor):
    faIntName=figActor.InternalName()
    sufInd=faIntName.find(':')
    faIntName=faIntName[0:sufInd]
    hairStats = getHairGroups(figActor)
    groupNames=hairStats[0]
    groupPop=hairStats[1]
    indcList=[]
    actorDataStr=[[],[]]
    polyDataStr=[[],[]]
    i=0
    numGroups=len(groupNames)

    for name in groupNames:
        polyDataStr[0].append(name)
        if not groupPop[i]:
            indcList=getHairGroupIndices(figActor,name)

        hgGroup=figActor.HairGroup(i)
        polyDataStr[1].append(indcList)
        i=i+1

    pgDict=dict(zip(polyDataStr[0],polyDataStr[1]))
    furProp.SetCustomData(faIntName+':PolyGroups',pgDict,0,0)

    return None

# iterates the list of figure actors (body parts) returned by the poser
# figure.Actors() Method and tests each one for hair groups
# CALLS buildHairGroupData on actors that have hair group(s)
def iterateFigureActors(figureName):
    furFigure=scene.Figure(figureName)
    furActList = furFigure.Actors()
    for furAct in furActList:
        hairGroupCount=furAct.NumHairGroups()
        if hairGroupCount > 0:
            buildPolyGroupData(furAct)

    return None





# START OF MAIN SCRIPT LOOP_____________________________________________>>
#_______________________________________________________________________>>
userInputDlg=wx.TextEntryDialog(parent=None,message='Please Enter Fur Product Name')
userInputDlg.ShowModal()
productName=userInputDlg.GetValue()
userInputDlg=None
selectedFigure=scene.CurrentFigure()
scnActors=scene.Actors()
for act in scnActors:
    if act.InternalName()=='FurCreatorProp':
        furProp=act
        break

if not selectedFigure:
    selectMsg=wx.MessageDialog(parent=None,message='Please Select Figure',style=wx.CENTER)
    selectMsg.ShowModal()
else:
    slctFigName=selectedFigure.Name()
    if not furProp:
        loadPropMsg=wx.MessageDialog(parent=None,message='Please Load the Fur Creator Prop',style=wx.CENTER)
        loadPropMsg.ShowModal()
    else:
        furProp.SetName(productName)
        iterateFigureActors(slctFigName)

figureName=selectedFigure.Name()
furProp.SetCustomData('Target_Figure',figureName,0,0)
msgDlg=wx.MessageDialog(parent=None,message=figureName+' Fur written to '+furProp.Name(),style=wx.CENTER)
msgDlg.ShowModal()

